<?php
/*
Plugin Name: Skrape
Plugin URI: http://www.4devz.com/skrape
Description: Allow skraping content from a website and inserting it as a wordpress post
Version: 0.1
Author: Alex Barger
Author URI: http://www.4devz.com
*/
/*
Coding style follows the way Postie was written (http://www.economysizegeek.com/?page_id=39)
*/
ob_start();
error_reporting(E_ERROR | E_PARSE);
define('SKRAPE_CAP', 'skrape_cap');
define("SKRAPE_ROOT",dirname(__FILE__));

/**
* This function handles setting up the basic permissions
*/
function SkrapeAdminPermissions() {
    global $wp_roles;
    $admin = $wp_roles->get_role("administrator");
    $admin->add_cap("config_skrape");
}

/**
*  This sets up the configuration menu
*/
function SkrapeMenu() {
    add_options_page("Configure Skrape",
            "Configure Skrape" , 
             0,
            "skrape/skrape.php",
            "ConfigureSkrape");
}

/**
* This handles actually showing the form
*/
function ConfigureSkrape() {
    SkrapeAdminPermissions();
    if (current_user_can('config_skrape')) {
        include(SKRAPE_ROOT . "/config_form.php");
    } else { 
		echo "Forbidden";
	}
}

// --------------------------------------------------------------------------
// activating and installing the plugin
// --------------------------------------------------------------------------

function skrape_install()
{
	global $wp_roles;

	// if there is at least one role with the SKRAPE_CAP capability, then
	// the plugin was previously been installed and we must not do
	// anything; don't rely that the cap is attachted to the same roles
	// as during installation because this could already be changed
	// by the administrator

	foreach($wp_roles->role_objects as $role)
	{
		if ($role->has_cap(SKRAPE_CAP))
			return;
	}

	$role = get_role('administrator');
	if ($role !== NULL)
		$role->add_cap(SKRAPE_CAP);
	$role = get_role('editor');
	if ($role !== NULL)
		$role->add_cap(SKRAPE_CAP);
}

function skrape_activate_1_x()
{
	//add_filter('the_content', 'skrape_php', 1);
}

function skrape_activate()
{
	add_action('admin_menu', 'skrape_install');
	//add_filter('the_content', 'execphp_restricted_eval_php', 1);
}

function skrape_init()
{
	global $wp_version;
	if (substr($wp_version, 0, 2) == "1.")
		skrape_activate_1_x();
	else
		skrape_activate();
}
//
add_filter('init', 'skrape_init');
//Add Menu Configuration
add_action("admin_menu","SkrapeMenu");
?>
